/*
	httpclient.h
	part of client to wininet http facilities
	
	version 2.2
	
	Written by Povilas Kanapickas [exec]

	This software comes "AS IS" therefore the author is NOT responsible for any 
	losses or damage it can cause.

	Published under GPL (see http://www.gnu.org/gpl)
*/

#include "httpclient.h"

void xTPostData::wAddData (const char *psName, const char *psValue)	{
	if (bCleared) sData = "";
		else sData+= "&";
	bCleared = false;
	sData+= psName;
	sData+= "=";
	sData+= psValue;
	};
//==================================
void xTPostData::wAddData (const char *psName, int iValue)	{
	if (bCleared) sData = "";
		else sData+= "&";
	bCleared = false;
	char sValue[10];
	sprintf (&sValue[0], "%d\0", iValue);
	sData+= psName;
	sData+= "=";
	sData+= &sValue[0];
	};
/*================================*/
void xTHeaders::wAddHeader(xTHeader *header)	{
	xTHeader *newHeader = new xTHeader;
	newHeader->sHeader = new char[strlen(header->sHeader)+1];
	newHeader->sValue = new char[strlen(header->sValue)+1];
	strcpy(newHeader->sHeader, header->sHeader);
	strcpy(newHeader->sValue, header->sValue);
	
	xHeaders.push_back(newHeader);
	};
/*================================*/	
void xTHeaders::wAddHeader(const char *psHeader, const char *psValue)	{
	xTHeader *newHeader = new xTHeader;
	newHeader->sHeader = new char[strlen(psHeader)+1];
	newHeader->sValue = new char[strlen(psValue)+1];
	strcpy(newHeader->sHeader, psHeader);
	strcpy(newHeader->sValue, psValue);
	
	xHeaders.push_back(newHeader);
	};
/*================================*/
xTHeaders::~xTHeaders()	{
	xTHeaderList::iterator iter;
	for (iter = xHeaders.begin();
		 iter!=xHeaders.end();
		 iter++) delete (*iter);
	};
/*================================*/
static string sHeader;
const char *xTHeaders::wGetHeaders ()	{

	xTHeaderList::iterator iter;
	sHeader = "";
	for (iter = xHeaders.begin();
		 iter!= xHeaders.end();
		 iter++)	{
			sHeader += (*iter)->sHeader;
			sHeader += ": ";
			sHeader += (*iter)->sValue;
			sHeader += "\r\n";}
	return sHeader.c_str();
	};
/*================================*/
xTHTTPConnection::xTHTTPConnection()	{
	sClient = "cinWAP/0.9.12";
	bConnected = false;
	//if (!InternetCheckConnection("http://www.google.com", FLAG_ICC_FORCE_CONNECTION, 0))
	//	return;
	xConnection = InternetOpen (sClient, INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);	
	if (!xConnection) return;
	bConnected = true;
	};
/*================================*/
xTHTTPSession::xTHTTPSession (xTHTTPConnection *connection, const char *server)	{
	psCookie = NULL;
	bConnected = false;
	if (!connection->wConnected()) return;
	xSession = InternetConnect( connection->wConnection(), server, INTERNET_DEFAULT_HTTP_PORT,
				NULL, NULL, INTERNET_SERVICE_HTTP, 0, 0);
	if (!xSession) return;
	bConnected = true;
	};
/*================================*/
long xTHTTPResource::wReadData(ulong length, char *buf)	{
	if (!bConnected) return 0;
	long lLength;
	if (!InternetQueryDataAvailable( xRequest, (DWORD*)&lLength, 0, 0))
		return 0;
	long lRead;
	if (!InternetReadFile( xRequest, buf, length, (DWORD*)&lRead))
		return 0;
	return lRead;
	}
/*=================================*/
xTHTTPResource::xTHTTPResource(xTHTTPSession *session, 
			 xTMethod verb, 
			 const char *sURL, 
			 const char *sReferer, 
			 xTHeaders *headers, 
			 const char *sData)	{
	bConnected = false;
	char *sVerb;
	switch (verb)	{
		case get: {sVerb = "GET"; break;}
		case put: {sVerb = "PUT"; break;}
		case post: {sVerb = "POST"; break;}
		}
	xRequest = HttpOpenRequest(session->wSession(), sVerb, sURL, NULL, sReferer, NULL, INTERNET_FLAG_KEEP_CONNECTION, 0);
	if (!xRequest) return;
	char *s = "\0";
	const char *sHeaders;
	if (!sData) sData = s;
	if (session->wGetCookie())	{
		if (!headers) headers = new xTHeaders;
		headers->wAddHeader ("Cookie", session->wGetCookie());
		}
	//HttpAddRequestHeaders (xRequest, "Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, */*", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	//HttpAddRequestHeaders (xRequest, "Accept-Language: lt", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	//HttpAddRequestHeaders (xRequest, "Content-Type: application/x-www-form-urlencoded", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	//HttpAddRequestHeaders (xRequest, "UA-CPU: x86", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	//HttpAddRequestHeaders (xRequest, "User-Agent: Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; .NET CLR 2.0.50727)", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	//HttpAddRequestHeaders (xRequest, "Host:  s4.travian.lt", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	//HttpAddRequestHeaders (xRequest, "Connection: Keep-Alive", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	//HttpAddRequestHeaders (xRequest, "Cache-Control: no-cache", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	//HttpAddRequestHeaders (xRequest, "Referer:  http://s4.travian.lt/", -1, HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	if (!headers) sHeaders = NULL;
	  else sHeaders = headers->wGetHeaders();
	if (!HttpSendRequest( xRequest, sHeaders, (ulong)-1, (void*)sData, strlen(sData)))
		return;
	
	char *sCookie=NULL;
	int iSize = 0;

	pgRetry:
	
	if(!HttpQueryInfo(xRequest,HTTP_QUERY_COOKIE,
		(LPVOID)sCookie,(DWORD*)&iSize,NULL))	{
		// This call will fail on the first pass, because 
		// no buffer is allocated.
			if (GetLastError()==ERROR_HTTP_HEADER_NOT_FOUND)	{
				// Code to handle the case where the header isn't available.
				goto pgEnd;
			}		
			else	{
				// Check for an insufficient buffer.
				if (GetLastError()==ERROR_INSUFFICIENT_BUFFER)	{
					// Allocate the necessary buffer.
					sCookie = new char[iSize+1];
					// Retry the call.
					goto pgRetry;				
					}		
				else  {
					// Error handling code.
					goto pgEnd;
					}		
				}		
		}	
	if (sCookie)
		session->wSetCookie(sCookie);
	pgEnd:
	bConnected = true;
	};
//===========================================
xTSimpleHTTPClient::xTSimpleHTTPClient()	{
	hbConnected = false;
	hpxConnection = NULL;
	hpxSession = NULL;
	hpxRes = NULL;
	hpsBuffer = new char[SIMPLEHTTPBUFLEN+1];
	}
//============================================
xTSimpleHTTPClient::~xTSimpleHTTPClient()	{
	if (hpxConnection) delete hpxConnection;
	if (hpxSession) delete hpxSession;
	if (hpxRes) delete hpxRes;
	delete[] hpsBuffer;
	}
//===========================================
int xTSimpleHTTPClient::wConnect(const char *psServer)	{
	if (!hbConnected)	{
		hpxConnection = new xTHTTPConnection;
		if (!hpxConnection->wConnected()) return 0;
		}
	if (strcmp (psServer, hpsLastServer) == 0) return 1;
	
	hpxSession = new xTHTTPSession(hpxConnection, psServer);
	
	hpsLastServer = new char [strlen(psServer) + 1];
	strcpy (hpsLastServer, psServer);
	
	if (!hpxSession->wConnected()) return 0;
	hbConnected = true;
	return 1;
	}
//===========================================
int xTSimpleHTTPClient::wGet(xTXMLFile *pxHTML, const char *psFile)	{
	hpxRes = new xTHTTPResource(hpxSession, get, psFile, NULL, NULL, NULL);
	if (!hpxRes->wConnected()) return 0;
	
	int iRead = hpxRes->wReadData(SIMPLEHTTPBUFLEN, hpsBuffer);
	*(hpsBuffer+iRead) =0;
	
	pxHTML->wFree();
	pxHTML->wReadFromBuffer(hpsBuffer, xTXMLFile::html);
	
	delete hpxRes;
	hpxRes = NULL;
	return 1;
	}
//===========================================
int xTSimpleHTTPClient::wPost(xTXMLFile *pxHTML, const char *psFile, const char *psData)	{
	hpxRes = new xTHTTPResource(hpxSession, post, psFile, NULL, NULL, psData);
	if (!hpxRes->wConnected()) return 0;
	
	int iRead = hpxRes->wReadData(SIMPLEHTTPBUFLEN, hpsBuffer);
	*(hpsBuffer+iRead) =0;
	
	pxHTML->wFree();
	pxHTML->wReadFromBuffer(hpsBuffer, xTXMLFile::html);
	
	delete hpxRes;
	hpxRes = NULL;
	return 1;
	}
//============================================
int xTSimpleHTTPClient::wGet(xTXMLFile *pxHTML, const char *psFile, const char *psData)	{
	hpxRes = new xTHTTPResource(hpxSession, get, psFile, NULL, NULL, psData);
	if (!hpxRes->wConnected()) return 0;
	
	int iRead = hpxRes->wReadData(SIMPLEHTTPBUFLEN, hpsBuffer);
	*(hpsBuffer+iRead) =0;
	
	pxHTML->wFree();
	pxHTML->wReadFromBuffer(hpsBuffer, xTXMLFile::html);
	
	delete hpxRes;
	hpxRes = NULL;
	return 1;
	}

